// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_MOCK_DEVICE_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_MOCK_DEVICE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace video_capture {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
const uint32_t kMockMediaDevice_AllocateAndStart_Name = 0;
class MockMediaDevice_AllocateAndStart_Params_Data {
 public:
  static MockMediaDevice_AllocateAndStart_Params_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(MockMediaDevice_AllocateAndStart_Params_Data))) MockMediaDevice_AllocateAndStart_Params_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;

 private:
  MockMediaDevice_AllocateAndStart_Params_Data() : header_({sizeof(*this), 0}) {
  }
  ~MockMediaDevice_AllocateAndStart_Params_Data() = delete;
};
static_assert(sizeof(MockMediaDevice_AllocateAndStart_Params_Data) == 16,
              "Bad sizeof(MockMediaDevice_AllocateAndStart_Params_Data)");
const uint32_t kMockMediaDevice_StopAndDeAllocate_Name = 1;
class MockMediaDevice_StopAndDeAllocate_Params_Data {
 public:
  static MockMediaDevice_StopAndDeAllocate_Params_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(MockMediaDevice_StopAndDeAllocate_Params_Data))) MockMediaDevice_StopAndDeAllocate_Params_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MockMediaDevice_StopAndDeAllocate_Params_Data() : header_({sizeof(*this), 0}) {
  }
  ~MockMediaDevice_StopAndDeAllocate_Params_Data() = delete;
};
static_assert(sizeof(MockMediaDevice_StopAndDeAllocate_Params_Data) == 8,
              "Bad sizeof(MockMediaDevice_StopAndDeAllocate_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_MOCK_DEVICE_MOJOM_SHARED_INTERNAL_H_