// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/video_capture/public/interfaces/service.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "media/mojo/interfaces/pipeline_statistics_struct_traits.h"
#include "media/base/ipc/media_param_traits_macros.h"
#include "media/capture/ipc/capture_param_traits.h"
#include "media/capture/mojo/video_capture_types_typemap_traits.h"
#include "services/video_capture/public/interfaces/device_descriptor_struct_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "services/service_manager/public/cpp/service_info_struct_traits.h"
#include "media/capture/ipc/capture_param_traits_macros.h"
#include "services/service_manager/public/cpp/interface_provider_spec_struct_traits.h"
#include "ipc/ipc_message_utils.h"
#include "services/video_capture/public/interfaces/capture_settings_traits.h"
#include "media/base/ipc/media_param_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojo/url_gurl_struct_traits.h"
#include "services/service_manager/public/cpp/identity_struct_traits.h"
namespace video_capture {
namespace mojom {
const char Service::Name_[] = "video_capture::mojom::Service";
const uint32_t Service::Version_;
bool Service::AddDeviceToMockFactory(::video_capture::mojom::MockMediaDevicePtr device, const media::VideoCaptureDeviceDescriptor& descriptor) {
  NOTREACHED();
  return false;
}
class Service_AddDeviceToMockFactory_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  Service_AddDeviceToMockFactory_HandleSyncResponse(
      scoped_refptr<mojo::AssociatedGroupController> group_controller,
      bool* result)
      : serialization_context_(std::move(group_controller)), result_(result) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  mojo::internal::SerializationContext serialization_context_;
  bool* result_;DISALLOW_COPY_AND_ASSIGN(Service_AddDeviceToMockFactory_HandleSyncResponse);
};
bool Service_AddDeviceToMockFactory_HandleSyncResponse::Accept(
    mojo::Message* message) {
  internal::Service_AddDeviceToMockFactory_ResponseParams_Data* params =
      reinterpret_cast<internal::Service_AddDeviceToMockFactory_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  Service_AddDeviceToMockFactory_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Service::AddDeviceToMockFactory response deserializer");
    return false;
  }
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}

class Service_AddDeviceToMockFactory_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Service_AddDeviceToMockFactory_ForwardToCallback(
      const Service::AddDeviceToMockFactoryCallback& callback,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : callback_(callback),
        serialization_context_(std::move(group_controller)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Service::AddDeviceToMockFactoryCallback callback_;
  mojo::internal::SerializationContext serialization_context_;
  DISALLOW_COPY_AND_ASSIGN(Service_AddDeviceToMockFactory_ForwardToCallback);
};
bool Service_AddDeviceToMockFactory_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::Service_AddDeviceToMockFactory_ResponseParams_Data* params =
      reinterpret_cast<internal::Service_AddDeviceToMockFactory_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  Service_AddDeviceToMockFactory_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Service::AddDeviceToMockFactory response deserializer");
    return false;
  }
  if (!callback_.is_null()) {
    mojo::internal::MessageDispatchContext context(message);
    callback_.Run();
  }
  return true;
}

ServiceProxy::ServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceProxy::ConnectToDeviceFactory(
    ::video_capture::mojom::DeviceFactoryRequest in_request) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::Service_ConnectToDeviceFactory_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kService_ConnectToDeviceFactory_Name, size);

  auto params =
      ::video_capture::mojom::internal::Service_ConnectToDeviceFactory_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::video_capture::mojom::DeviceFactoryRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in Service.ConnectToDeviceFactory request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

void ServiceProxy::ConnectToFakeDeviceFactory(
    ::video_capture::mojom::DeviceFactoryRequest in_request) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::Service_ConnectToFakeDeviceFactory_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kService_ConnectToFakeDeviceFactory_Name, size);

  auto params =
      ::video_capture::mojom::internal::Service_ConnectToFakeDeviceFactory_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::video_capture::mojom::DeviceFactoryRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in Service.ConnectToFakeDeviceFactory request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

void ServiceProxy::ConnectToMockDeviceFactory(
    ::video_capture::mojom::DeviceFactoryRequest in_request) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::Service_ConnectToMockDeviceFactory_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kService_ConnectToMockDeviceFactory_Name, size);

  auto params =
      ::video_capture::mojom::internal::Service_ConnectToMockDeviceFactory_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::video_capture::mojom::DeviceFactoryRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in Service.ConnectToMockDeviceFactory request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}
bool ServiceProxy::AddDeviceToMockFactory(
    ::video_capture::mojom::MockMediaDevicePtr param_device, const media::VideoCaptureDeviceDescriptor& param_descriptor) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::Service_AddDeviceToMockFactory_Params_Data);
  size += mojo::internal::PrepareToSerialize<::video_capture::mojom::DeviceDescriptorDataView>(
      param_descriptor, &serialization_context);

  mojo::internal::RequestMessageBuilder builder(internal::kService_AddDeviceToMockFactory_Name, size,
                                                mojo::Message::kFlagIsSync);

  auto params =
      ::video_capture::mojom::internal::Service_AddDeviceToMockFactory_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::video_capture::mojom::MockMediaDevicePtrDataView>(
      param_device, &params->device, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->device),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid device in Service.AddDeviceToMockFactory request");
  typename decltype(params->descriptor)::BaseType* descriptor_ptr;
  mojo::internal::Serialize<::video_capture::mojom::DeviceDescriptorDataView>(
      param_descriptor, builder.buffer(), &descriptor_ptr, &serialization_context);
  params->descriptor.Set(descriptor_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->descriptor.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null descriptor in Service.AddDeviceToMockFactory request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());

  bool result = false;
  mojo::MessageReceiver* responder =
      new Service_AddDeviceToMockFactory_HandleSyncResponse(
          group_controller_, &result);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
  return result;
}

void ServiceProxy::AddDeviceToMockFactory(
    ::video_capture::mojom::MockMediaDevicePtr in_device, const media::VideoCaptureDeviceDescriptor& in_descriptor, const AddDeviceToMockFactoryCallback& callback) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::video_capture::mojom::internal::Service_AddDeviceToMockFactory_Params_Data);
  size += mojo::internal::PrepareToSerialize<::video_capture::mojom::DeviceDescriptorDataView>(
      in_descriptor, &serialization_context);
  mojo::internal::RequestMessageBuilder builder(internal::kService_AddDeviceToMockFactory_Name, size);

  auto params =
      ::video_capture::mojom::internal::Service_AddDeviceToMockFactory_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::video_capture::mojom::MockMediaDevicePtrDataView>(
      in_device, &params->device, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->device),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid device in Service.AddDeviceToMockFactory request");
  typename decltype(params->descriptor)::BaseType* descriptor_ptr;
  mojo::internal::Serialize<::video_capture::mojom::DeviceDescriptorDataView>(
      in_descriptor, builder.buffer(), &descriptor_ptr, &serialization_context);
  params->descriptor.Set(descriptor_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->descriptor.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null descriptor in Service.AddDeviceToMockFactory request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  mojo::MessageReceiver* responder =
      new Service_AddDeviceToMockFactory_ForwardToCallback(
          callback, group_controller_);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
}
class Service_AddDeviceToMockFactory_ProxyToResponder {
 public:
  static Service::AddDeviceToMockFactoryCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController>
          group_controller) {
    std::unique_ptr<Service_AddDeviceToMockFactory_ProxyToResponder> proxy(
        new Service_AddDeviceToMockFactory_ProxyToResponder(
            request_id, is_sync, responder, group_controller));
    return base::Bind(&Service_AddDeviceToMockFactory_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Service_AddDeviceToMockFactory_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Service::AddDeviceToMockFactory() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
  }

 private:
  Service_AddDeviceToMockFactory_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(responder),
        serialization_context_(std::move(group_controller)) {
  }

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  mojo::MessageReceiverWithStatus* responder_;
  // TODO(yzshen): maybe I should use a ref to the original one?
  mojo::internal::SerializationContext serialization_context_;

  DISALLOW_COPY_AND_ASSIGN(Service_AddDeviceToMockFactory_ProxyToResponder);
};

void Service_AddDeviceToMockFactory_ProxyToResponder::Run(
    ) {
  size_t size = sizeof(::video_capture::mojom::internal::Service_AddDeviceToMockFactory_ResponseParams_Data);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kService_AddDeviceToMockFactory_Name, size, request_id_,
      is_sync_ ? mojo::Message::kFlagIsSync : 0);
  auto params =
      ::video_capture::mojom::internal::Service_AddDeviceToMockFactory_ResponseParams_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = responder_->Accept(builder.message());
  ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

// static
bool ServiceStubDispatch::Accept(
    Service* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kService_ConnectToDeviceFactory_Name: {
      internal::Service_ConnectToDeviceFactory_Params_Data* params =
          reinterpret_cast<internal::Service_ConnectToDeviceFactory_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      ::video_capture::mojom::DeviceFactoryRequest p_request{};
      Service_ConnectToDeviceFactory_ParamsDataView input_data_view(params,
                                              context);
      
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Service::ConnectToDeviceFactory deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "Service::ConnectToDeviceFactory");
      mojo::internal::MessageDispatchContext context(message);
      impl->ConnectToDeviceFactory(
std::move(p_request));
      return true;
    }
    case internal::kService_ConnectToFakeDeviceFactory_Name: {
      internal::Service_ConnectToFakeDeviceFactory_Params_Data* params =
          reinterpret_cast<internal::Service_ConnectToFakeDeviceFactory_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      ::video_capture::mojom::DeviceFactoryRequest p_request{};
      Service_ConnectToFakeDeviceFactory_ParamsDataView input_data_view(params,
                                              context);
      
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Service::ConnectToFakeDeviceFactory deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "Service::ConnectToFakeDeviceFactory");
      mojo::internal::MessageDispatchContext context(message);
      impl->ConnectToFakeDeviceFactory(
std::move(p_request));
      return true;
    }
    case internal::kService_ConnectToMockDeviceFactory_Name: {
      internal::Service_ConnectToMockDeviceFactory_Params_Data* params =
          reinterpret_cast<internal::Service_ConnectToMockDeviceFactory_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      ::video_capture::mojom::DeviceFactoryRequest p_request{};
      Service_ConnectToMockDeviceFactory_ParamsDataView input_data_view(params,
                                              context);
      
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Service::ConnectToMockDeviceFactory deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "Service::ConnectToMockDeviceFactory");
      mojo::internal::MessageDispatchContext context(message);
      impl->ConnectToMockDeviceFactory(
std::move(p_request));
      return true;
    }
    case internal::kService_AddDeviceToMockFactory_Name: {
      break;
    }
  }
  return false;
}

// static
bool ServiceStubDispatch::AcceptWithResponder(
    Service* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  switch (message->header()->name) {
    case internal::kService_ConnectToDeviceFactory_Name: {
      break;
    }
    case internal::kService_ConnectToFakeDeviceFactory_Name: {
      break;
    }
    case internal::kService_ConnectToMockDeviceFactory_Name: {
      break;
    }
    case internal::kService_AddDeviceToMockFactory_Name: {
      internal::Service_AddDeviceToMockFactory_Params_Data* params =
          reinterpret_cast<internal::Service_AddDeviceToMockFactory_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      ::video_capture::mojom::MockMediaDevicePtr p_device{};
      media::VideoCaptureDeviceDescriptor p_descriptor{};
      Service_AddDeviceToMockFactory_ParamsDataView input_data_view(params,
                                              context);
      
      p_device =
          input_data_view.TakeDevice<decltype(p_device)>();
      if (!input_data_view.ReadDescriptor(&p_descriptor))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Service::AddDeviceToMockFactory deserializer");
        return false;
      }
      Service::AddDeviceToMockFactoryCallback callback =
          Service_AddDeviceToMockFactory_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync), responder,
              context->group_controller);
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "Service::AddDeviceToMockFactory");
      mojo::internal::MessageDispatchContext context(message);
      impl->AddDeviceToMockFactory(
std::move(p_device), 
std::move(p_descriptor), callback);
      return true;
    }
  }
  return false;
}

bool ServiceRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "Service RequestValidator");

  switch (message->header()->name) {
    case internal::kService_ConnectToDeviceFactory_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Service_ConnectToDeviceFactory_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kService_ConnectToFakeDeviceFactory_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Service_ConnectToFakeDeviceFactory_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kService_ConnectToMockDeviceFactory_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Service_ConnectToMockDeviceFactory_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kService_AddDeviceToMockFactory_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Service_AddDeviceToMockFactory_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool ServiceResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "Service ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kService_AddDeviceToMockFactory_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Service_AddDeviceToMockFactory_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace video_capture

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif