// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "third_party/WebKit/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "cc/ipc/quads_struct_traits.h"
#include "cc/ipc/surface_id_struct_traits.h"
#include "gpu/ipc/common/sync_token_struct_traits.h"
#include "cc/ipc/shared_quad_state_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "cc/ipc/transferable_resource_struct_traits.h"
#include "cc/ipc/filter_operations_struct_traits.h"
#include "cc/ipc/render_pass_id_struct_traits.h"
#include "cc/ipc/filter_operation_struct_traits.h"
#include "ipc/ipc_message_utils.h"
#include "cc/ipc/render_pass_struct_traits.h"
#include "cc/ipc/compositor_frame_metadata_struct_traits.h"
#include "cc/ipc/surface_sequence_struct_traits.h"
#include "ui/events/mojo/latency_info_struct_traits.h"
#include "ui/gfx/mojo/transform_struct_traits.h"
#include "ui/gfx/mojo/selection_bound_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/CommonCustomTypesStructTraits.h"
#include "gpu/ipc/common/mailbox_holder_struct_traits.h"
#include "cc/ipc/begin_frame_args_struct_traits.h"
#include "cc/ipc/selection_struct_traits.h"
#include "gpu/ipc/common/mailbox_struct_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "skia/public/interfaces/image_filter_struct_traits.h"
#include "cc/ipc/returned_resource_struct_traits.h"
#include "cc/ipc/compositor_frame_struct_traits.h"
namespace blink {
namespace mojom {
namespace blink {
const char OffscreenCanvasSurface::Name_[] = "blink::mojom::OffscreenCanvasSurface";
const uint32_t OffscreenCanvasSurface::Version_;
bool OffscreenCanvasSurface::GetSurfaceId(cc::SurfaceId* surface_id) {
  NOTREACHED();
  return false;
}
class OffscreenCanvasSurface_GetSurfaceId_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  OffscreenCanvasSurface_GetSurfaceId_HandleSyncResponse(
      scoped_refptr<mojo::AssociatedGroupController> group_controller,
      bool* result, cc::SurfaceId* out_surface_id)
      : serialization_context_(std::move(group_controller)), result_(result), out_surface_id_(out_surface_id) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  mojo::internal::SerializationContext serialization_context_;
  bool* result_;
  cc::SurfaceId* out_surface_id_;DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasSurface_GetSurfaceId_HandleSyncResponse);
};
bool OffscreenCanvasSurface_GetSurfaceId_HandleSyncResponse::Accept(
    mojo::Message* message) {
  internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data* params =
      reinterpret_cast<internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  cc::SurfaceId p_surface_id{};
  OffscreenCanvasSurface_GetSurfaceId_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!input_data_view.ReadSurfaceId(&p_surface_id))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "OffscreenCanvasSurface::GetSurfaceId response deserializer");
    return false;
  }
  *out_surface_id_ = std::move(p_surface_id);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}

class OffscreenCanvasSurface_GetSurfaceId_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OffscreenCanvasSurface_GetSurfaceId_ForwardToCallback(
      const OffscreenCanvasSurface::GetSurfaceIdCallback& callback,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : callback_(callback),
        serialization_context_(std::move(group_controller)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  OffscreenCanvasSurface::GetSurfaceIdCallback callback_;
  mojo::internal::SerializationContext serialization_context_;
  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasSurface_GetSurfaceId_ForwardToCallback);
};
bool OffscreenCanvasSurface_GetSurfaceId_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data* params =
      reinterpret_cast<internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data*>(
          message->mutable_payload());
  
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  cc::SurfaceId p_surface_id{};
  OffscreenCanvasSurface_GetSurfaceId_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  if (!input_data_view.ReadSurfaceId(&p_surface_id))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "OffscreenCanvasSurface::GetSurfaceId response deserializer");
    return false;
  }
  if (!callback_.is_null()) {
    mojo::internal::MessageDispatchContext context(message);
    callback_.Run(
std::move(p_surface_id));
  }
  return true;
}

OffscreenCanvasSurfaceProxy::OffscreenCanvasSurfaceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
bool OffscreenCanvasSurfaceProxy::GetSurfaceId(
    cc::SurfaceId* param_surface_id) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data);

  mojo::internal::RequestMessageBuilder builder(internal::kOffscreenCanvasSurface_GetSurfaceId_Name, size,
                                                mojo::Message::kFlagIsSync);

  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());

  bool result = false;
  mojo::MessageReceiver* responder =
      new OffscreenCanvasSurface_GetSurfaceId_HandleSyncResponse(
          group_controller_, &result, param_surface_id);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
  return result;
}

void OffscreenCanvasSurfaceProxy::GetSurfaceId(
    const GetSurfaceIdCallback& callback) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kOffscreenCanvasSurface_GetSurfaceId_Name, size);

  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  mojo::MessageReceiver* responder =
      new OffscreenCanvasSurface_GetSurfaceId_ForwardToCallback(
          callback, group_controller_);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
}

void OffscreenCanvasSurfaceProxy::Require(
    const cc::SurfaceId& in_surface_id, const cc::SurfaceSequence& in_sequence) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_Require_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, &serialization_context);
  mojo::internal::MessageBuilder builder(internal::kOffscreenCanvasSurface_Require_Name, size);

  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_Require_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_id)::BaseType* surface_id_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, builder.buffer(), &surface_id_ptr, &serialization_context);
  params->surface_id.Set(surface_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_id in OffscreenCanvasSurface.Require request");
  typename decltype(params->sequence)::BaseType* sequence_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, builder.buffer(), &sequence_ptr, &serialization_context);
  params->sequence.Set(sequence_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->sequence.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sequence in OffscreenCanvasSurface.Require request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

void OffscreenCanvasSurfaceProxy::Satisfy(
    const cc::SurfaceSequence& in_sequence) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_Satisfy_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, &serialization_context);
  mojo::internal::MessageBuilder builder(internal::kOffscreenCanvasSurface_Satisfy_Name, size);

  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_Satisfy_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->sequence)::BaseType* sequence_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, builder.buffer(), &sequence_ptr, &serialization_context);
  params->sequence.Set(sequence_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->sequence.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sequence in OffscreenCanvasSurface.Satisfy request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}
class OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder {
 public:
  static OffscreenCanvasSurface::GetSurfaceIdCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController>
          group_controller) {
    std::unique_ptr<OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder> proxy(
        new OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder(
            request_id, is_sync, responder, group_controller));
    return base::Bind(&OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "OffscreenCanvasSurface::GetSurfaceId() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
  }

 private:
  OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(responder),
        serialization_context_(std::move(group_controller)) {
  }

  void Run(
      const cc::SurfaceId& in_surface_id);

  uint64_t request_id_;
  bool is_sync_;
  mojo::MessageReceiverWithStatus* responder_;
  // TODO(yzshen): maybe I should use a ref to the original one?
  mojo::internal::SerializationContext serialization_context_;

  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder);
};

void OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder::Run(
    const cc::SurfaceId& in_surface_id) {
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, &serialization_context_);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kOffscreenCanvasSurface_GetSurfaceId_Name, size, request_id_,
      is_sync_ ? mojo::Message::kFlagIsSync : 0);
  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_id)::BaseType* surface_id_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, builder.buffer(), &surface_id_ptr, &serialization_context_);
  params->surface_id.Set(surface_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_id in OffscreenCanvasSurface.GetSurfaceId response");
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = responder_->Accept(builder.message());
  ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

// static
bool OffscreenCanvasSurfaceStubDispatch::Accept(
    OffscreenCanvasSurface* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_GetSurfaceId_Name: {
      break;
    }
    case internal::kOffscreenCanvasSurface_Require_Name: {
      internal::OffscreenCanvasSurface_Require_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasSurface_Require_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      cc::SurfaceId p_surface_id{};
      cc::SurfaceSequence p_sequence{};
      OffscreenCanvasSurface_Require_ParamsDataView input_data_view(params,
                                              context);
      
      if (!input_data_view.ReadSurfaceId(&p_surface_id))
        success = false;
      if (!input_data_view.ReadSequence(&p_sequence))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasSurface::Require deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "OffscreenCanvasSurface::Require");
      mojo::internal::MessageDispatchContext context(message);
      impl->Require(
std::move(p_surface_id), 
std::move(p_sequence));
      return true;
    }
    case internal::kOffscreenCanvasSurface_Satisfy_Name: {
      internal::OffscreenCanvasSurface_Satisfy_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasSurface_Satisfy_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      cc::SurfaceSequence p_sequence{};
      OffscreenCanvasSurface_Satisfy_ParamsDataView input_data_view(params,
                                              context);
      
      if (!input_data_view.ReadSequence(&p_sequence))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasSurface::Satisfy deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "OffscreenCanvasSurface::Satisfy");
      mojo::internal::MessageDispatchContext context(message);
      impl->Satisfy(
std::move(p_sequence));
      return true;
    }
  }
  return false;
}

// static
bool OffscreenCanvasSurfaceStubDispatch::AcceptWithResponder(
    OffscreenCanvasSurface* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_GetSurfaceId_Name: {
      internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      OffscreenCanvasSurface_GetSurfaceId_ParamsDataView input_data_view(params,
                                              context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasSurface::GetSurfaceId deserializer");
        return false;
      }
      OffscreenCanvasSurface::GetSurfaceIdCallback callback =
          OffscreenCanvasSurface_GetSurfaceId_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync), responder,
              context->group_controller);
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "OffscreenCanvasSurface::GetSurfaceId");
      mojo::internal::MessageDispatchContext context(message);
      impl->GetSurfaceId(callback);
      return true;
    }
    case internal::kOffscreenCanvasSurface_Require_Name: {
      break;
    }
    case internal::kOffscreenCanvasSurface_Satisfy_Name: {
      break;
    }
  }
  return false;
}

bool OffscreenCanvasSurfaceRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "OffscreenCanvasSurface RequestValidator");

  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_GetSurfaceId_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurface_GetSurfaceId_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOffscreenCanvasSurface_Require_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurface_Require_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOffscreenCanvasSurface_Satisfy_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurface_Satisfy_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool OffscreenCanvasSurfaceResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "OffscreenCanvasSurface ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_GetSurfaceId_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurface_GetSurfaceId_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
const char OffscreenCanvasCompositorFrameSinkProvider::Name_[] = "blink::mojom::OffscreenCanvasCompositorFrameSinkProvider";
const uint32_t OffscreenCanvasCompositorFrameSinkProvider::Version_;

OffscreenCanvasCompositorFrameSinkProviderProxy::OffscreenCanvasCompositorFrameSinkProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OffscreenCanvasCompositorFrameSinkProviderProxy::CreateCompositorFrameSink(
    const cc::SurfaceId& in_surface_id, ::cc::mojom::blink::MojoCompositorFrameSinkClientPtr in_client, ::cc::mojom::blink::MojoCompositorFrameSinkRequest in_sink) {
   mojo::internal::SerializationContext serialization_context(
      group_controller_);
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, &serialization_context);
  mojo::internal::MessageBuilder builder(internal::kOffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Name, size);

  auto params =
      ::blink::mojom::internal::OffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Params_Data::New(builder.buffer());
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_id)::BaseType* surface_id_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, builder.buffer(), &surface_id_ptr, &serialization_context);
  params->surface_id.Set(surface_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_id in OffscreenCanvasCompositorFrameSinkProvider.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::MojoCompositorFrameSinkClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in OffscreenCanvasCompositorFrameSinkProvider.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::MojoCompositorFrameSinkRequestDataView>(
      in_sink, &params->sink, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->sink),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid sink in OffscreenCanvasCompositorFrameSinkProvider.CreateCompositorFrameSink request");
  (&serialization_context)->handles.Swap(
      builder.message()->mutable_handles());
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

// static
bool OffscreenCanvasCompositorFrameSinkProviderStubDispatch::Accept(
    OffscreenCanvasCompositorFrameSinkProvider* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Name: {
      internal::OffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Params_Data*>(
              message->mutable_payload());
      
      (context)->handles.Swap((message)->mutable_handles());
      bool success = true;
      cc::SurfaceId p_surface_id{};
      ::cc::mojom::blink::MojoCompositorFrameSinkClientPtr p_client{};
      ::cc::mojom::blink::MojoCompositorFrameSinkRequest p_sink{};
      OffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_ParamsDataView input_data_view(params,
                                              context);
      
      if (!input_data_view.ReadSurfaceId(&p_surface_id))
        success = false;
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      p_sink =
          input_data_view.TakeSink<decltype(p_sink)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasCompositorFrameSinkProvider::CreateCompositorFrameSink deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      TRACE_EVENT0("mojom", "OffscreenCanvasCompositorFrameSinkProvider::CreateCompositorFrameSink");
      mojo::internal::MessageDispatchContext context(message);
      impl->CreateCompositorFrameSink(
std::move(p_surface_id), 
std::move(p_client), 
std::move(p_sink));
      return true;
    }
  }
  return false;
}

// static
bool OffscreenCanvasCompositorFrameSinkProviderStubDispatch::AcceptWithResponder(
    OffscreenCanvasCompositorFrameSinkProvider* impl,
    mojo::internal::SerializationContext* context,
    mojo::Message* message,
    mojo::MessageReceiverWithStatus* responder) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Name: {
      break;
    }
  }
  return false;
}

bool OffscreenCanvasCompositorFrameSinkProviderRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "OffscreenCanvasCompositorFrameSinkProvider RequestValidator");

  switch (message->header()->name) {
    case internal::kOffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasCompositorFrameSinkProvider_CreateCompositorFrameSink_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif