// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_BLINK_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_BLINK_H_

#include <stdint.h>

#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/lib/union_accessor.h"
#include "mojo/public/cpp/bindings/map.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/no_interface.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/WebKit/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-shared.h"
#include "cc/ipc/compositor_frame.mojom-blink.h"
#include "cc/ipc/mojo_compositor_frame_sink.mojom-blink.h"
#include "cc/ipc/surface_id.mojom-blink.h"
#include "cc/ipc/surface_sequence.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "mojo/public/cpp/bindings/wtf_array.h"
#include "mojo/public/cpp/bindings/wtf_map.h"
#include "third_party/WebKit/Source/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/wtf/Optional.h"
#include "third_party/WebKit/Source/wtf/text/WTFString.h"
#include "third_party/WebKit/public/platform/WebSize.h"
#include "third_party/WebKit/Source/wtf/text/WTFString.h"
#include "cc/resources/returned_resource.h"
#include "cc/output/begin_frame_args.h"
#include "cc/surfaces/surface_sequence.h"
#include "cc/surfaces/surface_id.h"
#include "cc/output/compositor_frame.h"
#include "third_party/WebKit/public/platform/WebCommon.h"


namespace blink {
namespace mojom {
namespace blink {
class OffscreenCanvasSurface;
using OffscreenCanvasSurfacePtr = mojo::InterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfacePtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasSurface>;
using ThreadSafeOffscreenCanvasSurfacePtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceRequest = mojo::InterfaceRequest<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasSurface>;
using ThreadSafeOffscreenCanvasSurfaceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasSurface>;

class OffscreenCanvasCompositorFrameSinkProvider;
using OffscreenCanvasCompositorFrameSinkProviderPtr = mojo::InterfacePtr<OffscreenCanvasCompositorFrameSinkProvider>;
using OffscreenCanvasCompositorFrameSinkProviderPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasCompositorFrameSinkProvider>;
using ThreadSafeOffscreenCanvasCompositorFrameSinkProviderPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasCompositorFrameSinkProvider>;
using OffscreenCanvasCompositorFrameSinkProviderRequest = mojo::InterfaceRequest<OffscreenCanvasCompositorFrameSinkProvider>;
using OffscreenCanvasCompositorFrameSinkProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasCompositorFrameSinkProvider>;
using ThreadSafeOffscreenCanvasCompositorFrameSinkProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasCompositorFrameSinkProvider>;
using OffscreenCanvasCompositorFrameSinkProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasCompositorFrameSinkProvider>;
using OffscreenCanvasCompositorFrameSinkProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasCompositorFrameSinkProvider>;


class OffscreenCanvasSurfaceProxy;

template <typename ImplRefTraits>
class OffscreenCanvasSurfaceStub;

class OffscreenCanvasSurfaceRequestValidator;
class OffscreenCanvasSurfaceResponseValidator;

class BLINK_PLATFORM_EXPORT OffscreenCanvasSurface
    : public OffscreenCanvasSurfaceInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = false;
  static const bool HasSyncMethods_ = true;

  using Proxy_ = OffscreenCanvasSurfaceProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasSurfaceStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasSurfaceRequestValidator;
  using ResponseValidator_ = OffscreenCanvasSurfaceResponseValidator;
  virtual ~OffscreenCanvasSurface() {}

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  virtual bool GetSurfaceId(cc::SurfaceId* surface_id);

  using GetSurfaceIdCallback = base::Callback<void(const cc::SurfaceId&)>;
  virtual void GetSurfaceId(const GetSurfaceIdCallback& callback) = 0;

  virtual void Require(const cc::SurfaceId& surface_id, const cc::SurfaceSequence& sequence) = 0;

  virtual void Satisfy(const cc::SurfaceSequence& sequence) = 0;
};

class OffscreenCanvasCompositorFrameSinkProviderProxy;

template <typename ImplRefTraits>
class OffscreenCanvasCompositorFrameSinkProviderStub;

class OffscreenCanvasCompositorFrameSinkProviderRequestValidator;

class BLINK_PLATFORM_EXPORT OffscreenCanvasCompositorFrameSinkProvider
    : public OffscreenCanvasCompositorFrameSinkProviderInterfaceBase {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;
  static const bool PassesAssociatedKinds_ = false;
  static const bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasCompositorFrameSinkProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasCompositorFrameSinkProviderStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasCompositorFrameSinkProviderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  virtual ~OffscreenCanvasCompositorFrameSinkProvider() {}

  virtual void CreateCompositorFrameSink(const cc::SurfaceId& surface_id, ::cc::mojom::blink::MojoCompositorFrameSinkClientPtr client, ::cc::mojom::blink::MojoCompositorFrameSinkRequest sink) = 0;
};

class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceProxy
    : public OffscreenCanvasSurface {
 public:
  explicit OffscreenCanvasSurfaceProxy(mojo::MessageReceiverWithResponder* receiver);
  bool GetSurfaceId(cc::SurfaceId* surface_id) override;
  void GetSurfaceId(const GetSurfaceIdCallback& callback) override;
  void Require(const cc::SurfaceId& surface_id, const cc::SurfaceSequence& sequence) override;
  void Satisfy(const cc::SurfaceSequence& sequence) override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};

class BLINK_PLATFORM_EXPORT OffscreenCanvasCompositorFrameSinkProviderProxy
    : public OffscreenCanvasCompositorFrameSinkProvider {
 public:
  explicit OffscreenCanvasCompositorFrameSinkProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void CreateCompositorFrameSink(const cc::SurfaceId& surface_id, ::cc::mojom::blink::MojoCompositorFrameSinkClientPtr client, ::cc::mojom::blink::MojoCompositorFrameSinkRequest sink) override;

  void set_group_controller(
        scoped_refptr<mojo::AssociatedGroupController> group_controller) {
    group_controller_ = std::move(group_controller);
  }
 private:
  mojo::MessageReceiverWithResponder* receiver_;
  scoped_refptr<mojo::AssociatedGroupController> group_controller_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceStubDispatch {
 public:
  static bool Accept(OffscreenCanvasSurface* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(OffscreenCanvasSurface* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasSurface>>
class OffscreenCanvasSurfaceStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasSurfaceStub() {}
  ~OffscreenCanvasSurfaceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasCompositorFrameSinkProviderStubDispatch {
 public:
  static bool Accept(OffscreenCanvasCompositorFrameSinkProvider* impl,
                     mojo::internal::SerializationContext* context,
                     mojo::Message* message);
  static bool AcceptWithResponder(OffscreenCanvasCompositorFrameSinkProvider* impl,
                                  mojo::internal::SerializationContext* context,
                                  mojo::Message* message,
                                  mojo::MessageReceiverWithStatus* responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasCompositorFrameSinkProvider>>
class OffscreenCanvasCompositorFrameSinkProviderStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasCompositorFrameSinkProviderStub() {}
  ~OffscreenCanvasCompositorFrameSinkProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  mojo::internal::SerializationContext* serialization_context() {
    return &serialization_context_;
  }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasCompositorFrameSinkProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasCompositorFrameSinkProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), &serialization_context_, message,
        responder);
  }

 private:
  ImplPointerType sink_;
  mojo::internal::SerializationContext serialization_context_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasCompositorFrameSinkProviderRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_BLINK_H_