// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "third_party/WebKit/public/platform/referrer.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/WebKit/public/web/WindowFeaturesStructTraits.h"
#include "url/mojo/origin_struct_traits.h"
#include "content/public/common/referrer_struct_traits.h"
#include "content/common/media/media_session_struct_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "content/common/bluetooth/web_bluetooth_device_id_struct_traits.h"
#include "ipc/ipc_message_utils.h"
#include "device/bluetooth/public/interfaces/uuid_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "third_party/WebKit/public/platform/ReferrerPolicyEnumTraits.h"
#include "url/mojo/url_gurl_struct_traits.h"
namespace blink {
namespace mojom {// static
ReferrerPtr Referrer::New() {
  ReferrerPtr rv;
  mojo::internal::StructHelper<Referrer>::Initialize(&rv);
  return rv;
}

Referrer::Referrer()
    : url(),
      policy() {
}

Referrer::~Referrer() {
}
}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::Referrer::DataView, ::blink::mojom::ReferrerPtr>::Read(
    ::blink::mojom::Referrer::DataView input,
    ::blink::mojom::ReferrerPtr* output) {
  bool success = true;
  ::blink::mojom::ReferrerPtr result(::blink::mojom::Referrer::New());
  
      if (!input.ReadUrl(&result->url))
        success = false;
      if (!input.ReadPolicy(&result->policy))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif